
/*
 * JComboBox Demo 1
 *
 * إߤ@Check Box
 */

import java.awt.*;

import java.awt.event.*;

import javax.swing.*;



class JComboBoxDemo1 extends JFrame implements ActionListener, ItemListener{

	private JComboBox comboBox;

	public static void main(String args[]) {

		JComboBoxDemo1 cb = new JComboBoxDemo1();

		cb.setVisible(true);

	} // main

	public JComboBoxDemo1() {

		Container contentPane = getContentPane();
		JPanel comboPanel, okPanel;
		JButton ok;
		String [] sports = {"Swimming", "Tennis", "Golf", "Car Racing", "Basketball", "Baseball"};

		// Set up JFrame
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setTitle("JComboBoxDemo1.java");
		setSize(300, 200);
		setLocation(150, 250);

		contentPane.setLayout(new BorderLayout());

		comboBox = new JComboBox(sports);
		comboBox.addItemListener(this);

		comboPanel = new JPanel(new FlowLayout());
		comboPanel.add(comboBox);
		comboPanel.setBorder(BorderFactory.createTitledBorder("Favorite Sport"));

		ok = new JButton("Favorite");
		ok.addActionListener(this);

		okPanel = new JPanel(new FlowLayout());
		okPanel.add(ok);

		contentPane.add(comboPanel, BorderLayout.CENTER);
		contentPane.add(okPanel, BorderLayout.SOUTH);

	} // Constructor

	public void actionPerformed(ActionEvent e) {

		String sports = "Your beloved sports are : \n";
		sports = sports + (String) comboBox.getSelectedItem();

		int loc = comboBox.getSelectedIndex();

		JOptionPane.showMessageDialog(null, sports + "and it is located at " + loc);

	} // actionPerformed

	public void itemStateChanged(ItemEvent e) {

		String state;

		if ( e.getStateChange() == ItemEvent.SELECTED) {

			state = "selected";

		} else {

			state = "deselected";

		} // else

		JOptionPane.showMessageDialog(null, e.getItem() + " " +state);

	} // itemStateChanged

} // JComboBoxDemo1
