
/*
 * JFileChooser Demo 1
 *
 * إߤ@ӥisXJFileChooser
 */

import java.awt.*;

import java.io.*;

import java.awt.event.*;

import javax.swing.*;

class JFileChooserDemo1 extends JFrame implements ActionListener{

		private JMenu file;

		private JMenu edit;

		private JFileChooser fc;

		private File f;

		JScrollPane jsp ;

		private JTextArea ta;

	public static void main(String args[]) {

		JFileChooserDemo1 JFC = new JFileChooserDemo1();

		JFC.setVisible(true);

	} // main

	public JFileChooserDemo1() {

		Container contentPane = getContentPane();

		setTitle("JFileChooserDemo1.java");

		setSize(350, 250);

		setLocation(200, 300);

		createFile();

		createEdit();

		JMenuBar menubar = new JMenuBar();

		setJMenuBar(menubar); // ]wJFrameJMenuBar

		menubar.add(file);

		menubar.add(edit);

		ta = new JTextArea();

		jsp = new JScrollPane(ta);

		jsp.setBorder(BorderFactory.createTitledBorder("JScrollPane"));

		contentPane.add(jsp);

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		// غcFile Chooser
		fc = new JFileChooser();

	} // Constructor

	public void actionPerformed(ActionEvent e) {

		String menu;

		menu = e.getActionCommand();

		try {

		if(menu.equals("Quit")) {

			System.exit(0);

		} else if (menu.equals("Open...")){

			// }File ChooserܧX
			int status = fc.showOpenDialog(null);


				if(status == JFileChooser.APPROVE_OPTION) {

						// oҿwɮ
						f = fc.getSelectedFile();

						openFile(f);

				} else {

						System.out.println("}ɮסC");

					} // else

		}	else{

			;

		} //esle

		} catch(IOException ex) {

				System.out.println(ex);

			} // catch

	} // actionPerformed

	private void createFile() {

		JMenuItem item;

		file = new JMenu("File");

		item = new JMenuItem("New");
		item.addActionListener(this);
		file.add(item);

		item = new JMenuItem("Open...");
		item.addActionListener(this);
		file.add(item);

		item = new JMenuItem("Save");
		item.addActionListener(this);
		file.add(item);

		item = new JMenuItem("Save As...");
		item.addActionListener(this);
		file.add(item);

		file.addSeparator(); // [W@ju

		item = new JMenuItem("Quit");
		item.addActionListener(this);
		file.add(item);

	} // createFile()

	private void createEdit() {

		JMenuItem item;

		edit = new JMenu("Edit");

		item = new JMenuItem("Cut");
		item.addActionListener(this);
		edit.add(item);

		item = new JMenuItem("Copy");
		item.addActionListener(this);
		edit.add(item);

		item = new JMenuItem("Paste");
		item.addActionListener(this);
		edit.add(item);

	} // createEdit()

	private void openFile(File f) throws IOException{

		FileReader fileReader = new FileReader(f);

		BufferedReader br = new BufferedReader(fileReader);

		String str;

		while((str = br.readLine()) != null) {

			ta.append(str + "\n");

		} // while

		br.close();

	} // openFile()

} // JFileChooserDemo1

