
/*
 * JRadioButton Demo 1
 *
 * إߤ@Radio Button
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class JRadioButtonDemo1 extends JFrame implements ActionListener{

	private JRadioButton radio[];
	private ButtonGroup group;

	public static void main(String args[]) {

		JRadioButtonDemo1 rb = new JRadioButtonDemo1();

		rb.setVisible(true);

	} // main

	public JRadioButtonDemo1() {

		Container contentPane;
		JPanel radioPanel, okPanel;
		JButton ok;
		String [] sports = {"Swimming", "Tennis", "Golf", "Car Racing", "Basketball", "Baseball"};

		// Set up JFrame
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setTitle("JRadioButtonDemo1.java");
		setSize(300, 200);
		setLocation(150, 250);

		contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout());

		radioPanel = new JPanel(new FlowLayout());
		radioPanel.setBorder(BorderFactory.createTitledBorder("Favorite Sport"));

		radio = new JRadioButton[sports.length];
		group = new ButtonGroup();

		for(int i = 0; i < radio.length; i++) {

			radio[i] = new JRadioButton(sports[i]);
			group.add(radio[i]);
			radioPanel.add(radio[i]);

		} // for

		okPanel = new JPanel(new FlowLayout());
		ok = new JButton("Favorite");
		ok.addActionListener(this);
		okPanel.add(ok);

		contentPane.add(radioPanel, BorderLayout.CENTER);
		contentPane.add(okPanel, BorderLayout.SOUTH);

	} // Constructor

	public void actionPerformed(ActionEvent e) {

		StringBuffer sports = new StringBuffer("Your beloved sports are : \n");

		for(int i = 0; i < radio.length; i++) {

			if(radio[i].isSelected()) {

				sports.append(radio[i].getText());

			} // if

		} // for

		JOptionPane.showMessageDialog(null, sports.toString());

	} // actionPerformed

} // JRadioButtonDemo1
