/*
 * JdbcDemo14.java
 *
 * JDBC{
 */

import java.awt.*;

import java.awt.event.*;

import javax.swing.*;

import java.util.*;

import java.text.*;

import java.sql.*;

import java.util.*;

import java.io.*;

public class JdbcDemo14 extends JFrame implements ActionListener{

	JButton createTable, addRecord, addFromFile, query, delete, exit;
	JTextArea output;
	JScrollPane jsp;
	JPanel south;

	Connection conn;
	Statement stmt;
	ResultSet rs;
	ResultSet temprs;

	public static void main(String args[]) {

		JdbcDemo14 jd = new JdbcDemo14();
		jd.setVisible(true);

	} // main

	public JdbcDemo14(){

		try{

			Container contentPane = getContentPane();

			setTitle("JDBC Application");
			setSize(600, 600);
			setLocation(250, 200);
			contentPane.setLayout(new BorderLayout());

			// Connect to the DBMS
			Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
			String url = "jdbc:odbc:Store";
			conn = DriverManager.getConnection(url);
			stmt = conn.createStatement();


			createTable = new JButton("Create Table");
			createTable.addActionListener(this);

			addRecord = new JButton("Add Record");
			addRecord.addActionListener(this);

			addFromFile = new JButton("Add File");
			addFromFile.addActionListener(this);

			query = new JButton("Query");
			query.addActionListener(this);

			delete = new JButton("Delete");
			delete.addActionListener(this);

			exit = new JButton("Exit");
			exit.addActionListener(this);

			south = new JPanel(new FlowLayout());
			south.add(createTable);
			south.add(addRecord);
			south.add(addFromFile);
			south.add(query);
			south.add(delete);
			south.add(exit);

			output = new JTextArea();
			output.setEditable(false);

			jsp = new JScrollPane(output);
			jsp.setBorder(BorderFactory.createTitledBorder("Output"));

			contentPane.add(jsp, BorderLayout.CENTER);
			contentPane.add(south, BorderLayout.SOUTH);

			setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

			} catch(Exception e) {

				System.out.println(e);

			} // catch

		}//JdbcDemo22()

	public void actionPerformed(ActionEvent e) {

		try{

			if(e.getSource() instanceof JButton) {

					JButton clicked = (JButton) e.getSource();

					if(clicked == createTable) {

						String sql = JOptionPane.showInputDialog(null,
						"пJإߪ檺SQLykG ", "إߪ",
						JOptionPane.INFORMATION_MESSAGE );

						if(sql != null)
							stmt.executeUpdate(sql);

					} else if(clicked == addRecord) {

						String sql = JOptionPane.showInputDialog(null,
						"пJ[JƪSQLykG ", "[J",
						JOptionPane.INFORMATION_MESSAGE );

						if(sql != null) {

							stmt.executeUpdate(sql);
							output.append("Record added.\n");

						} // if

					}else if(clicked == query) {

						stmt = conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,
						ResultSet.CONCUR_UPDATABLE);

						String sql = JOptionPane.showInputDialog(null,
						"пJdߤSQLOG", "d߸",
						JOptionPane.INFORMATION_MESSAGE );

						ResultSet rs = stmt.executeQuery(sql);// SQLO
						temprs = rs;
						String c = "*************************New Query*************************\n";
						output.append(c);
						ResultSetMetaData meta = rs.getMetaData();

						boolean first = true;
						int index = 1;
						while( rs.next()) {
							if(first) {

								output.append("record #\t");
								for( int i = 1; i <= meta.getColumnCount(); i++) {
									output.append(meta.getColumnName(i) + "\t");
								}// for
									output.append("\n");
									first = false;
							} // if

							output.append(index + "\t");

							for(int i = 1; i <= meta.getColumnCount(); i++) {
								output.append(rs.getString(i) + "\t");
							}// for

							output.append("\n");
							index ++;
						} // while


					}else if(clicked == delete){

						String line = JOptionPane.showInputDialog(null,
						"пJRCXG ", "R",
						JOptionPane.INFORMATION_MESSAGE );

						int lineNum = Integer.parseInt(line.trim());

						temprs.absolute(lineNum);
						temprs.deleteRow();
						output.append("Record deleted.\n");

					}else if(clicked == addFromFile){

						String fileName = JOptionPane.showInputDialog(null,
						"пJ[JƪɮצW١G ", "[J",
						JOptionPane.INFORMATION_MESSAGE );

						String line;
						String senderName = "";
						String receiverName = "";
						String State = "";
						int ID = -1;
						double Fee = 0.0;
						int index = 0 ;

						BufferedReader br = new BufferedReader(
														 new FileReader(fileName.trim()));

						while((line = br.readLine()) != null) {

							if(index > 0) {

								StringTokenizer st = new StringTokenizer(line.trim(), "|");

								while(st.hasMoreTokens()) {

									senderName = st.nextToken().trim();
									receiverName = st.nextToken().trim();
									ID = Integer.parseInt(st.nextToken().trim());
									Fee = Double.parseDouble(st.nextToken().trim().substring(1));
									State = st.nextToken();

								}// while

								String ins = "Insert Into Package Values (\'" +
								senderName + "\',\'" +receiverName + "\'," +
								ID + "," + Fee + ",\'" + State + "\' )";

								System.out.println(ins);
								stmt.executeUpdate(ins);

							} 	else{

								index++;

							} // else

						} // while

						output.append("Insertion Finished");

					}else if(clicked == exit) {


						stmt.close();
						conn.close();
						System.exit(1);

					} // else if

			} // if

		} catch(SQLException ex) {

			JOptionPane.showMessageDialog(null,
			"yk~θƪwsb\n", "SQLException",
			JOptionPane.WARNING_MESSAGE);

			System.out.println(ex.getMessage());

		}  catch(Exception ex) {

			System.out.println(ex);

		} // catch

	}//action()

}//JdbcDemo14

