/*
 * JDBC Demo 6
 *
 * dߦhӪ椤
 */

import java.sql.*;

class JdbcDemo6 {

    public static void main (String[] args) {
        try {

            // Ĥ@BGŪi JDBC Driver
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");

            // ĤGBGإ߻PƮws
            String url = "jdbc:odbc:Store";
            Connection conn = DriverManager.getConnection(url);

			// ĤTBGŧiStatement for sending SQL statements to the database
			Statement stmt = conn.createStatement();


			String query = "SELECT Package.senderName, Personnel.Name " +
			   "FROM Package, Personnel " +
			   "WHERE Package.ID = 10 and Personnel.ID = 10";

			ResultSet rs = stmt.executeQuery(query);

			while (rs.next()) {
				String sender = rs.getString("senderName");
				String name = rs.getString("Name");
				System.out.println(sender + "\t" + name);
			}

			rs.close();
			stmt.close();
			conn.close();

        } catch (Exception e) {
            System.err.println(e.getMessage());
        }  // catch

    }  // main

} // JdbcDemo6
