/*
 * MergeSort.java
 */

 class MergeSort {

	int record[] = {5, 7, 12, 3, 9, 33, 23, 11};

	int record2[] = {1,6,8,10,12,15,20};

	int record3[] = {2,4,7,9, 13,18};

	int record4[] = new int[13];

	public MergeSort(){

		Process(record);

		printArray(record);

	} // Constructor

    public static void main(String args[]) {

	 	new MergeSort();

	}//main

	public void Process(int a[]) {

		int temp[] = new int[a.length];

		Process(a, temp, 0, a.length -1);

	}// Process()

	private static void Process(int r[], int temp[], int left, int right){

		if(left < right) {

			int center = (left + right) / 2;

			Process(r, temp, left, center);

			Process(r, temp, center + 1, right);

			merge( r, temp, left, center + 1, right);

		}//if

	}//Process()

	private static void merge(int a[], int temp[], int left, int right, int rightEnd){

		int leftEnd = right -1;

		int tmp = left;

		int numElements = rightEnd - left + 1;

		while( left <= leftEnd && right <= rightEnd)

			if( a[left] <= a[right] )

				temp[tmp++] = a[left++];

			else

				temp[tmp++] = a[right++];

		while(left <= leftEnd)

			temp[tmp++] = a[left++];

		while(right <= rightEnd)

			temp[tmp++] = a[right++];

		for(int i = 0; i < numElements; i++, rightEnd--)

			a[rightEnd] = temp[rightEnd];

	}//merge

	private void printArray(int p[]) {

		for(int i = 0; i < p.length; i++) {

			System.out.print(p[i]+"  ");

		}//for

	}//printArray

}//MergeSort



