
/*
 * QuickSortDemo1.java
 */

class QuickSortDemo1 {

	public static void main(String args[]) {

		int record[] = {5, 7, 12, 3, 9, 33, 23, 11};

		quicksort(record, 0, 7);

		for ( int i = 0; i < record.length; i++) {
			System.out.print(record[i] + "\t");
		} // for

	} // main

	private static void quicksort(int a[], int low, int high) {

		if(low >= high)
			return;

		else {

			int pivot = a[high];
			int i = low;
			int j = high -1;

			while(i < j) {

				while (a[i] <= pivot && i < high) {

					i++;

				} // while

				while(a[j] > pivot && j > low) {

					j--;

				} // while

				if(i < j) {

					int temp = a[i];
					a[i] = a[j];
					a[j] = temp;

				} // if

			} // while

			if( !(i == high - 1 && a[i] < pivot)) {

				a[high] = a[i];
				a[i] = pivot;

			} // if

			quicksort(a, low, i - 1);
			quicksort(a, i + 1, high);

		} // else

	} // quicksort()

} // QuickSortDemo1