
 class QuickSort_temp
  {
	int record[] = {5, 7, 12, 3, 9, 33, 23, 11, 1, 34, 55, 2, 66, 8, 10, 39, 77, 99, 13, 96, 17, 21, 56, 43, 92, 25, 35};
	//int record[] = {5, 7, 12, 3, 9, 33, 23, 11};
	private final static int CUTOFF = 2;

	public QuickSort_temp(){
		quicksort(record);
		printArray(record);
		}

    public static void main(String args[]){
	 	new QuickSort_temp();
	   }//main

	public void quicksort(int r[]){
		quicksort(r, 0, r.length -1);
		}// quicksort()

	private static void quicksort(int a[], int low, int high){

			if(low+CUTOFF >  high){
				//System.out.println("low = " + low + "high = " + high);
				insertionSort(a, low, high);
				}
			else{
				int pivot = a[high];
				//System.out.println("pivot = " + pivot);
				int i = low;
				int j = high - 1;

				while(i<j){
					while( a[i] <= pivot && i < high){

						i++;

						}
					while(a[j] > pivot && j > low){

						j--;

						}

					if(i < j){
						int temp = a[i];
						a[i] = a[j];
						a[j] = temp;
					}
				}//while

				if(!(i == high - 1 && a[i] < pivot)){
					a[high] = a[i];
					a[i] = pivot;
				}
				//printArray(a);
				//System.out.println();
				quicksort( a, low, i - 1);
				quicksort( a, i + 1, high);
			}//else
		}// quicksort()

	private static int[] swapReferences(int a[], int j, int k){
		int temp = a[j];
		a[j] = a[k];
		a[k] = temp;
		return a;
		}// swapReferences()

	private static void insertionSort(int r[], int l, int h){
		/*System.out.println("Printing r: where l = " + l + " r[l] = " + r[l] + " h = " + h + " r[h] = " + r[h]);
		for(int i=l; i<=h; i++)
			System.out.print(r[i] + "\t");
		System.out.println("=============");*/
		for(int p = l; p <= h ; p++)
			   {
			   		int temp = r[p];
			   		int j = p;
					for ( ; j > 0 && temp < r[j-1] ; j--)
					{
						r[ j ] = r[ j - 1];
					}//for

				r[j] = temp;
	   }//for
	   		/*System.out.println("After insertion sort : Printing r: where l = " + l + " r[l] = " + r[l] + " h = " + h + " r[h] = " + r[h]);
	   		for(int i=l; i<=h; i++)
	   			System.out.print(r[i] + "\t");
		System.out.println("=============");*/
	}//insertionSort()

	private static void printArray(int p[]){
		for(int i = 0; i < p.length; i++){
			System.out.print(p[i]+"  ");
			}//for
		}//printArray
}//QuickSort_temp



