import java.awt.*;
import java.awt.event.*;
import java.util.*;

class MyCanvas extends Canvas
{
   String start;
   String to;
   boolean b=false;
   double cost;
   
	public void paint(Graphics g)
	{
	//map
		Digraph dig = new Digraph();
  		dig.readGraph("map.dat");
		
		//Font font = new Font("Monospaced", Font.PLAIN,12);
		//g.setFont(font);
		g.setColor(Color.red);
		int d = 10;
		
		//size parameter
		double c = 1.2;  //position miltipler
		double cycles=d/2; //cycle switch
		double sx = 100;  // x switch
		double sy = 3; // y switch
		double as = 5; //arrow swith
		
		
		for ( int i= 1; i<=dig.size; i++) 
		{
		
			g.setColor(Color.red);
			g.fillOval((int)(dig.x[i]*c+sx-cycles), (int)(dig.y[i]*c+sy-cycles), d, d);
			g.setColor(Color.black);		
			g.drawString(Integer.toString(i,10),(int)(dig.x[i]*c+sx),(int)(dig.y[i]*c+sy+cycles*2+as));
		}
		
		
		
		//System.out.println(dig.idxlink);
		for ( int i=0; i< dig.idxlink; i++)
		{
			//draw links
			g.setColor(Color.yellow);
			g.drawLine((int)(dig.x[(dig.link[i][0])]*c+sx), (int)(dig.y[(dig.link[i][0])]*c+sy),
					  (int)(dig.x[(dig.link[i][1])]*c+sx), (int)(dig.y[(dig.link[i][1])]*c+sy));
			
			
			//g.fillOval((int)(dig.x[(dig.link[i][1])])*2, (int)(dig.y[(dig.link[i][1])])*2, 5, 5);
			
			
			//int[] xpoint = {(int)dig.x[(dig.link[i][1])]*2-10, (int)dig.x[(dig.link[i][1])]*2-10, (int)dig.x[(dig.link[i][1])]*2 };
			//int[] ypoint = {(int)dig.y[(dig.link[i][1])]*2+10, (int)dig.y[(dig.link[i][1])]*2-10, (int)dig.y[(dig.link[i][1])]*2 };
			
			//draw arrow
			g.setColor(Color.yellow);
			if ( (int)dig.x[(dig.link[i][0])]==(int)dig.x[(dig.link[i][1])] &&
			      (int)dig.y[(dig.link[i][0])] > (int)dig.y[(dig.link[i][1])] )
			
			{       
				
				//g.setColor(Color.cyan);
				//System.out.println(dig.link[i][0] + " " + dig .link[i][1]);
				g.drawLine((int)(dig.x[(dig.link[i][1])]*c+sx),(int)(dig.y[(dig.link[i][1])]*c+sy+cycles),
				                  (int)(dig.x[(dig.link[i][1])]*c+sx-as),(int)(dig.y[(dig.link[i][1])]*c+sy+cycles+as)
				                  );
				g.drawLine((int)(dig.x[(dig.link[i][1])]*c+sx),(int)(dig.y[(dig.link[i][1])]*c+sy+cycles),
				                  (int)(dig.x[(dig.link[i][1])]*c+sx+as),(int)(dig.y[(dig.link[i][1])]*c+sy+cycles+as)
				                  );                  
			}
			
			if ( (int)dig.x[(dig.link[i][0])] == (int)dig.x[(dig.link[i][1])] &&
			      (int)dig.y[(dig.link[i][0])] < (int)dig.y[(dig.link[i][1])] )
			
			{       
				//System.out.println(dig.link[i][0] + " " + dig .link[i][1]);
				g.drawLine((int)(dig.x[(dig.link[i][1])]*c+sx),(int)(dig.y[(dig.link[i][1])]*c+sy-cycles),
				                  (int)(dig.x[(dig.link[i][1])]*c+sx-as),(int)(dig.y[(dig.link[i][1])]*c+sy-cycles-as)
				                  );
				g.drawLine((int)(dig.x[(dig.link[i][1])]*c+sx),(int)(dig.y[(dig.link[i][1])]*c+sy-cycles),
				                  (int)(dig.x[(dig.link[i][1])]*c+sx+as),(int)(dig.y[(dig.link[i][1])]*c+sy-cycles-as)
				                  );                  
			}
			
			if ( (int)dig.x[(dig.link[i][0])] > (int)dig.x[(dig.link[i][1])]  &&
			      (int)dig.y[(dig.link[i][0])] == (int)dig.y[(dig.link[i][1])] )
			
			{       
				//System.out.println(dig.link[i][0] + " " + dig .link[i][1]);
				g.drawLine((int)(dig.x[(dig.link[i][1])]*c+sx+cycles),(int)(dig.y[(dig.link[i][1])]*c+sy),
				                  (int)(dig.x[(dig.link[i][1])]*c+sx+cycles+as),(int)(dig.y[(dig.link[i][1])]*c+sy-as)
				                  );
				g.drawLine((int)(dig.x[(dig.link[i][1])]*c+sx+cycles),(int)(dig.y[(dig.link[i][1])]*c+sy),
				                  (int)(dig.x[(dig.link[i][1])]*c+sx+cycles+as),(int)(dig.y[(dig.link[i][1])]*c+sy+as)
				                  );                  
			}
			
			if ( (int)dig.x[(dig.link[i][0])] < (int)dig.x[(dig.link[i][1])] &&
			      (int)dig.y[(dig.link[i][0])] == (int)dig.y[(dig.link[i][1])] )
			
			{     
				//System.out.println(dig.link[i][0] + " " + dig .link[i][1]);
				g.drawLine((int)(dig.x[(dig.link[i][1])]*c+sx-cycles),(int)(dig.y[(dig.link[i][1])]*c+sy),
				                  (int)(dig.x[(dig.link[i][1])]*c+sx-cycles-as),(int)(dig.y[(dig.link[i][1])]*c+sy-as)
				                  );
				g.drawLine((int)(dig.x[(dig.link[i][1])]*c+sx-cycles),(int)(dig.y[(dig.link[i][1])]*c+sy),
				                  (int)(dig.x[(dig.link[i][1])]*c+sx-cycles-as),(int)(dig.y[(dig.link[i][1])]*c+sy+as)
				                  );                  
			}
			
			if ( (int)dig.x[(dig.link[i][0])] < (int)dig.x[(dig.link[i][1])] &&
			      (int)dig.y[(dig.link[i][0])] < (int)dig.y[(dig.link[i][1])] )
			
			{       
				//System.out.println(dig.link[i][0] + " " + dig .link[i][1]);
				g.drawLine((int)(dig.x[(dig.link[i][1])]*c+sx-cycles),(int)(dig.y[(dig.link[i][1])]*c+sy-cycles),
				                  (int)(dig.x[(dig.link[i][1])]*c+sx-cycles-as),(int)(dig.y[(dig.link[i][1])]*c+sy-cycles)
				                  );
				g.drawLine((int)(dig.x[(dig.link[i][1])]*c+sx-cycles),(int)(dig.y[(dig.link[i][1])]*c+sy-cycles),
				                  (int)(dig.x[(dig.link[i][1])]*c+sx-cycles),(int)(dig.y[(dig.link[i][1])]*c+sy-cycles-as)
				                  );                  
			}
			
			if ( (int)dig.x[(dig.link[i][0])] < (int)dig.x[(dig.link[i][1])] &&
			      (int)dig.y[(dig.link[i][0])] > (int)dig.y[(dig.link[i][1])] )
			
			{      
				//System.out.println(dig.link[i][0] + " " + dig .link[i][1]);
				g.drawLine((int)(dig.x[(dig.link[i][1])]*c+sx-cycles),(int)(dig.y[(dig.link[i][1])]*c+sy+cycles),
				                  (int)(dig.x[(dig.link[i][1])]*c+sx-cycles-as),(int)(dig.y[(dig.link[i][1])]*c+sy+cycles)
				                  );
				g.drawLine((int)(dig.x[(dig.link[i][1])]*c+sx-cycles),(int)(dig.y[(dig.link[i][1])]*c+sy+cycles),
				                  (int)(dig.x[(dig.link[i][1])]*c+sx-cycles),(int)(dig.y[(dig.link[i][1])]*c+sy+cycles+as)
				                  );                  
			}
			
			if ( (int)dig.x[(dig.link[i][0])] > (int)dig.x[(dig.link[i][1])] &&
			      (int)dig.y[(dig.link[i][0])] > (int)dig.y[(dig.link[i][1])] )
			
			{     
				//System.out.println(dig.link[i][0] + " " + dig .link[i][1]);
				g.drawLine((int)(dig.x[(dig.link[i][1])]*c+sx+cycles),(int)(dig.y[(dig.link[i][1])]*c+sy+cycles),
				                  (int)(dig.x[(dig.link[i][1])]*c+sx+cycles+as),(int)(dig.y[(dig.link[i][1])]*c+sy+cycles)
				                  );
				g.drawLine((int)(dig.x[(dig.link[i][1])]*c+sx+cycles),(int)(dig.y[(dig.link[i][1])]*c+sy+cycles),
				                  (int)(dig.x[(dig.link[i][1])]*c+sx+cycles),(int)(dig.y[(dig.link[i][1])]*c+sy+cycles+as)
				                  );                  
			}
			
			if ( (int)dig.x[(dig.link[i][0])] > (int)dig.x[(dig.link[i][1])] &&
			      (int)dig.y[(dig.link[i][0])] < (int)dig.y[(dig.link[i][1])] )
			
			{     
				//System.out.println(dig.link[i][0] + " " + dig .link[i][1]);
				g.drawLine((int)(dig.x[(dig.link[i][1])]*c+sx+cycles),(int)(dig.y[(dig.link[i][1])]*c+sy-cycles),
				                  (int)(dig.x[(dig.link[i][1])]*c+sx+cycles+as),(int)(dig.y[(dig.link[i][1])]*c+sy-cycles)
				                  );
				g.drawLine((int)(dig.x[(dig.link[i][1])]*c+sx+cycles),(int)(dig.y[(dig.link[i][1])]*c+sy-cycles),
				                  (int)(dig.x[(dig.link[i][1])]*c+sx+cycles),(int)(dig.y[(dig.link[i][1])]*c+sy-cycles-as)
				                  );                  
			}
			
			
			
		} 	
		
		//train
		g.setColor(Color.black);
		g.drawLine((int)(dig.x[1]*c+sx),(int)(dig.y[1]*c+sy),(int)(dig.x[102]*c+sx),(int)(dig.y[102]*c+sy));
		

	
	if(b==true)
	{	
		dig.processQuery(start, to);
		g.setColor(Color.green);
	        
	        cost = dig.min;
	        System.out.println("cost="+cost);
	        
		for ( int i= 0; i<dig.ri; i++) 
		{
			int temp1 = Integer.parseInt(dig.route[i]);
			int temp2 = Integer.parseInt(dig.route[i+1]);
			
			g.fillOval((int)(dig.x[temp1]*c+sx-cycles), (int)(dig.y[temp1]*c+sy-cycles), d, d);
			
			g.drawLine((int)(dig.x[temp1]*c+sx), (int)(dig.y[temp1]*c+sy),
					  (int)(dig.x[temp2]*c+sx), (int)(dig.y[temp2]*c+sy));
					  
		}
		int temp1 = Integer.parseInt(dig.route[dig.ri]);
		g.fillOval((int)(dig.x[temp1]*c+sx-cycles), (int)(dig.y[temp1]*c+sy-cycles), d, d);
  		
  		//font = new Font("Monospaced", Font.PLAIN,18);
		//g.setFont(font);
  		g.drawString(("Start = "+ start), 700, 50);
  		g.drawString(("Destanation = "+ to ), 700, 65 );
  		g.drawString(("Shortest distance = "+ (int)dig.min), 700, 80);
	
	}

	}
}


public class draw2 extends Frame
{
	private MyCanvas myCanvas=new MyCanvas();
	private Button shortestPath=new Button("shortestPath");

	TextField text1;
	TextField text2;
	Label fromNode;
	Label toNode;
	String start, to;
	double cost;
        //for menu
        Font font=new Font("TimesRoman", Font.PLAIN,20);
        String type="TimesRoman";
        int style=0;
        int fontSize=10;
        MenuBar bar;
        Menu viewMenu, fontMenu, colorMenu, styleMenu,sizeMenu;
        CheckboxMenuItem checkboxMenuItem;
        MenuItem color1,color2, color3, font1,font2,font3,style1,style2,style3,size10,size12,size16,size20,size24,
                        size32,size48,size64;
	public draw2()
	{
		super ("draw2.java");
		//for color
		colorMenu=new Menu("Color");
		color1=new MenuItem("Black");
		color2=new MenuItem("Blue");
		color3=new MenuItem("Gray");
		colorMenu.add(color1);
		colorMenu.add(color2);
		colorMenu.add(color3);
		color1.addActionListener(new MyActionListener());
		color2.addActionListener(new MyActionListener());
		color3.addActionListener(new MyActionListener());
		
		//for font
		fontMenu=new Menu("Font");
		font1=new MenuItem("Times Roman");
		font2=new MenuItem("Courier");
		font3=new MenuItem("Times New Roman");
		fontMenu.add(font1);
		fontMenu.add(font2);
		fontMenu.add(font3);
		font1.addActionListener(new MyActionListener());
		font2.addActionListener(new MyActionListener());
		font3.addActionListener(new MyActionListener());
		
		//for style
		styleMenu=new Menu("Style");
		style1=new MenuItem("PlAIN");
		style2=new MenuItem("ITALIC");
		style3=new MenuItem("BOLD");
		styleMenu.add(style1);
		styleMenu.add(style2);
		styleMenu.add(style3);
		style1.addActionListener(new MyActionListener());
		style2.addActionListener(new MyActionListener());
		style3.addActionListener(new MyActionListener());
		
		//for size
		
		sizeMenu=new Menu("Size");
		size10=new MenuItem("10");
		size12=new MenuItem("12");
		size16=new MenuItem("16");
		size20=new MenuItem("20");
		size24=new MenuItem("24");
		size32=new MenuItem("32");
		size48=new MenuItem("48");
		size64=new MenuItem("64");
		sizeMenu.add(size10);
		sizeMenu.add(size12);
		sizeMenu.add(size16);
		sizeMenu.add(size20);
		sizeMenu.add(size24);
		sizeMenu.add(size32);
		sizeMenu.add(size48);
		sizeMenu.add(size64);
		size10.addActionListener(new MyActionListener());
		size12.addActionListener(new MyActionListener());
		size16.addActionListener(new MyActionListener());
		size20.addActionListener(new MyActionListener());
		size24.addActionListener(new MyActionListener());
		size32.addActionListener(new MyActionListener());
		size48.addActionListener(new MyActionListener());
		size64.addActionListener(new MyActionListener());
		
		viewMenu=new Menu("View");
		viewMenu.add(fontMenu);
		viewMenu.add(new MenuItem("-"));
		viewMenu.add(colorMenu);
		viewMenu.add(new MenuItem("-"));
		viewMenu.add(styleMenu);
		viewMenu.add(new MenuItem("-"));
		viewMenu.add(sizeMenu);
		viewMenu.add(new MenuItem("-"));
		checkboxMenuItem=new CheckboxMenuItem("Read-only");
		viewMenu.add(checkboxMenuItem);
		bar=new MenuBar();
		bar.add(viewMenu);
		setMenuBar(bar);
		myCanvas.setSize(1000,600);
		setLayout(new FlowLayout(FlowLayout.CENTER));
		//repaint();
		add(fromNode=new Label("Start Node"));
		add(text1=new TextField(10));
		add(toNode=new Label("Destination Node"));
		add(text2=new TextField(10));
		add(shortestPath);
		add(myCanvas);
                //myCanvas.setBackground(Color.blue);
                setSize(1000,600);
		setVisible(true);
		addWindowListener(new MyWindowListener());
		text1.addTextListener(new MyTextListener());
		text2.addTextListener(new MyTextListener());
		shortestPath.addActionListener(new anotherActionListener());
	}


class anotherActionListener implements ActionListener
{
	public void actionPerformed(ActionEvent e)
	{
 
 	 String command=e.getActionCommand();
  	if (command.equals("shortestPath"))
  	{
  		myCanvas.b=true;
  		myCanvas.start=start;
  		myCanvas.to=to;
  		myCanvas.repaint();
  		
  		
 	}

  
	}
}

class MyActionListener implements ActionListener
{
public void actionPerformed(ActionEvent e)
{
String cmd=e.getActionCommand();
if(cmd.equals("Black"))
myCanvas.setBackground(Color.black);
else if(cmd.equals("Blue"))
myCanvas.setBackground(Color.blue);
else if(cmd.equals("Gray"))
myCanvas.setBackground(Color.gray);
else if(cmd.equals("Times Roman"))
{
type="TimesRoman";
font=new Font(type,style,fontSize);
myCanvas.setFont(font);
}
else if(cmd.equals("Courier"))
{
type="Courier";
font=new Font(type,style,fontSize);
myCanvas.setFont(font);
}
else if(cmd.equals("Times New Roman"))
{
type="TimesNewRoman";
font=new Font(type,style,fontSize);
myCanvas.setFont(font);
}
else if(cmd.equals("PLAIN"))
{
style=Font.PLAIN;
font=new Font(type,style,fontSize);
myCanvas.setFont(font);
}
else if(cmd.equals("ITALIC"))
{
style=Font.ITALIC;
font=new Font(type,style,fontSize);
myCanvas.setFont(font);
}
else if(cmd.equals("BOLD"))
{
style=Font.BOLD;
font=new Font(type,style,fontSize);
myCanvas.setFont(font);
}
else if(cmd.equals("10"))
{
fontSize=10;
font=new Font(type,style,fontSize);
myCanvas.setFont(font);
}
else if(cmd.equals("12"))
{
fontSize=12;
font=new Font(type,style,fontSize);
myCanvas.setFont(font);
}
else if(cmd.equals("16"))
{
fontSize=16;
font=new Font(type,style,fontSize);
myCanvas.setFont(font);
}
else if(cmd.equals("20"))
{
fontSize=20;
font=new Font(type,style,fontSize);
myCanvas.setFont(font);
}
else if(cmd.equals("24"))
{
fontSize=24;
font=new Font(type,style,fontSize);
myCanvas.setFont(font);
}
else if(cmd.equals("32"))
{
fontSize=32;
font=new Font(type,style,fontSize);
myCanvas.setFont(font);
}
else if(cmd.equals("48"))
{
fontSize=48;
font=new Font(type,style,fontSize);
myCanvas.setFont(font);
}
else if(cmd.equals("64"))
{
fontSize=64;
font=new Font(type,style,fontSize);
myCanvas.setFont(font);
}
repaint();
}
}

class MyTextListener implements TextListener
{
	public void textValueChanged(TextEvent e)
	{
	 start=text1.getText();
	//start=Integer.parseInt(s1);
	 to=text2.getText();
	//dest=Integer.parseInt(s2);
	
	//System.out.println("start"+start);
	//System.out.println("to"+to);
	/*
	if(Integer.parseInt(start)>118 || Integer.parseInt(to) > 118) {
		System.out.println("Start/To point is bigger than 118");
		//g.drawString("Start/To point is bigger than 118", 700, 50);
	}
	else if (Integer.parseInt(start) < 1 || Integer.parseInt(to) < 1) {
		System.out.println("Start/To points is smaller than 1");
		//g.drawString("Start/To points is smaller than 1", 700, 65);
	}
	*/
	}
}

class MyWindowListener extends WindowAdapter
{
	public  void windowClosing(WindowEvent e)
	{
		System.exit(-1);
	}
}


public static void main(String args[])
{
new draw2();
}
}
