public static void main( String args ) {
	System.out.println( "пJGraphɮ" );
	BufferedReader in = new BufferedReader ( new InputStreamReader ( System.in ) );

	FileReader fin;
	String fileName = "";

	try{
		fileName = in.readLine();
		fin = new FileReader( fileName );
	}//try
	catch( Exception e ){
		System.err.println(e);
		return;
	}//catch

	BufferedReader graphFile = new BufferedReader( fin );
	Graph g = new Graph();

	try{
		String line;
		while( (line = graphFile.readLine( ) ) != null ){
			StringTokenizer st = new StringTokenizer( line );
			try{
				if( st.countTokens() != 3)
					throw new Exception();
				String source = st.nextToken();
				String dest = st.nextToken();
				int cost = Integer.parseInt( st.nextToken() );
				g.addEdge( source, dest, cost );
			}//try
			catch(Exception e){
				System.err.println( " Error: " + line );
			}//catch
		}//while
	}//try
	catch( Exception e ){
		System.err.println( "Error: " + e );
	}//catch
	while( g.processRequest( in ) )
		;
}//main

