
/*
 * JMenu Demo 1
 *
 * إߤ@ӦJMenu
 */

import java.awt.*;

import java.awt.event.*;

import javax.swing.*;

class JMenuDemo1 extends JFrame implements ActionListener{

		private JMenu file;

		private JMenu edit;

		private JLabel  label;

	public static void main(String args[]) {

		JMenuDemo1 JM = new JMenuDemo1();

		JM.setVisible(true);

	} // main

	public JMenuDemo1() {

		Container contentPane = getContentPane();

		setTitle("JMenuDemo1.java");

		setSize(350, 250);

		setLocation(200, 300);

		setResizable(false);

		contentPane.setBackground(Color.green);

		contentPane.setLayout(null);

		createFile();

		createEdit();

		JMenuBar menubar = new JMenuBar();

		setJMenuBar(menubar); // ]wJFrameJMenuBar

		menubar.add(file);

		menubar.add(edit);

		label = new JLabel("oܤrC");

		label.setBounds(50, 50, 250, 50);

		contentPane.add(label);

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);



	} // Constructor

	public void actionPerformed(ActionEvent e) {

		String menu;

		menu = e.getActionCommand();

		if(menu.equals("Quit")) {

			System.exit(0);

		} else {

			label.setText("ܤF" + "Menu " + menu );

		} //esle

	} // actionPerformed

	private void createFile() {

		JMenuItem item;

		file = new JMenu("File");

		item = new JMenuItem("New");
		item.addActionListener(this);
		file.add(item);

		item = new JMenuItem("Open...");
		item.addActionListener(this);
		file.add(item);

		item = new JMenuItem("Save");
		item.addActionListener(this);
		file.add(item);

		item = new JMenuItem("Save As...");
		item.addActionListener(this);
		file.add(item);

		file.addSeparator(); // [W@ju

		item = new JMenuItem("Quit");
		item.addActionListener(this);
		file.add(item);

	} // createFile()

	private void createEdit() {

		JMenuItem item;

		edit = new JMenu("Edit");

		item = new JMenuItem("Cut");
		item.addActionListener(this);
		edit.add(item);

		item = new JMenuItem("Copy");
		item.addActionListener(this);
		edit.add(item);

		item = new JMenuItem("Paste");
		item.addActionListener(this);
		edit.add(item);

	} // createEdit()

} // JMenuDemo1

