
/*
 * MouseEvent Demo 2
 *
 * Qηƹbø
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class MouseEventDemo2 extends JFrame implements MouseListener, MouseMotionListener{

	private int lastX = 0;
	private int lastY = 0;

	public static void main(String args[]) {

		MouseEventDemo2 ME = new MouseEventDemo2();

		ME.setVisible(true);

	} // main

	public MouseEventDemo2() {

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		setTitle("MouseEventDemo2.java");

		setSize(300, 200);

		setLocation(150, 250);

		addMouseListener(this);

		addMouseMotionListener(this);

	} // Constructor

	public void mouseClicked(MouseEvent e) {

	} // mouseClicked

	public void mouseEntered(MouseEvent e) {

		System.out.println("Mouse Enter.");

	} //mouseEntered

	public void mouseExited(MouseEvent e) {

		System.out.println("Mouse Exit.");

	} //mouseExited

	public void mousePressed(MouseEvent e) {

		int x = e.getX();

		int y = e.getY();

		if( e.isMetaDown() ) {// Is right button clicked?

			Graphics g = getGraphics();
			Rectangle r = getBounds();
			g.clearRect(0, 0, r.width, r.height);
			g.dispose();

		} else {

			lastX = x;
			lastY = y;

		} // else

	} //mousePressed

	public void mouseReleased(MouseEvent e) {

		System.out.println("Mouse Up.");

	} //mouseReleased

	public void mouseDragged(MouseEvent e) {

		int x = e.getX();
		int y = e.getY();

		if(!e.isMetaDown()) {

			Graphics g = getGraphics();

			g.drawLine(lastX, lastY, x, y);
			g.dispose();

			lastX = x;
			lastY = y;

		} // if

	} // mouseDragged

	public void mouseMoved(MouseEvent e) {

	} // mouseMoved

} // MouseEventDemo2
