/*
 * Filter.java
 *
 * إߤ@~Ӧclass FileFilter
 * iHLoɦW
 */

import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

public class Filter extends FileFilter {

    public boolean accept(File f) {

        if (f.isDirectory()) {
            return true;

        } // if

        if (extension(f) != null) {

            if (extension(f).equalsIgnoreCase("java") ||
                extension(f).equalsIgnoreCase("txt") ) {
                    return true;
            } else {
                return false;
            } // else

        } // if

        return false;
    } // accept()

    public String getDescription() {

        return "JAVA or Text Files";

    } // getDescription()

    private String extension(File f) {

		String file = f.getName();
		int dot = file.lastIndexOf(".");

		if(dot > 0 && dot < file.length() - 1) {
			return file.substring(dot+1);
		}else{
			return "";
		} // else

	} // extension

} // Filter


