
/*
 * JCheckBox Demo 1
 *
 * إߤ@Check Box
 */

import java.awt.*;

import java.awt.event.*;

import javax.swing.*;

class JCheckBoxDemo1 extends JFrame implements ActionListener{

	private JCheckBox[] checkBox;

	public static void main(String args[]) {

		JCheckBoxDemo1 cb = new JCheckBoxDemo1();

		cb.setVisible(true);

	} // main

	public JCheckBoxDemo1() {

		Container contentPane;
		JPanel checkPanel, okPanel;
		JButton ok;
		String [] sports = {"Swimming", "Tennis", "Golf", "Car Racing", "Basketball", "Baseball"};

		// Set up JFrame
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setTitle("JCheckBoxDemo1.java");
		setSize(300, 200);
		setLocation(150, 250);

		contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout());

		checkPanel = new JPanel(new FlowLayout());
		checkPanel.setBorder(BorderFactory.createTitledBorder("Favorite Sport"));

		checkBox = new JCheckBox[sports.length];

		for(int i = 0; i < checkBox.length; i++) {

			checkBox[i] = new JCheckBox(sports[i]);
			checkPanel.add(checkBox[i]);

		} // for

		okPanel = new JPanel(new FlowLayout());
		ok = new JButton("Favorite");
		ok.addActionListener(this);
		okPanel.add(ok);

		contentPane.add(checkPanel, BorderLayout.CENTER);
		contentPane.add(okPanel, BorderLayout.SOUTH);

	} // Constructor

	public void actionPerformed(ActionEvent e) {

		StringBuffer sports = new StringBuffer("Your beloved sports are : \n");
		int index = 1;

		for(int i = 0; i < checkBox.length; i++) {

			if(checkBox[i].isSelected()) {

				sports.append(index + ". " +checkBox[i].getText() + "\n");
				index++;

			} // if

		} // for

		JOptionPane.showMessageDialog(null, sports.toString());

	} // actionPerformed

} // JCheckBoxDemo1
