
/*
 * JCheckBoxMenuItem Demo 1
 *
 * إߤ@ӦJCheckBoxMenuItemJRadioButtonMenuItem
 */

import java.awt.*;

import java.awt.event.*;

import javax.swing.*;

class JCheckBoxMenuItemDemo1 extends JFrame implements ActionListener{

		private JMenu file;
		private JMenu edit;
		private JCheckBoxMenuItem cbmi;
		private JRadioButtonMenuItem rbmi;
		private JLabel  label;

	public static void main(String args[]) {

		JCheckBoxMenuItemDemo1 cbm = new JCheckBoxMenuItemDemo1();
		cbm.setVisible(true);

	} // main

	public JCheckBoxMenuItemDemo1() {

		Container contentPane = getContentPane();

		setTitle("JCheckBoxMenuItemDemo1.java");
		setSize(350, 250);
		setLocation(200, 300);
		setResizable(false);

		contentPane.setBackground(Color.green);
		contentPane.setLayout(null);

		createFile();
		createEdit();

		JMenuBar menubar = new JMenuBar();
		setJMenuBar(menubar); // ]wJFrameJMenuBar

		menubar.add(file);
		menubar.add(edit);

		label = new JLabel("oܤrC");
		label.setBounds(50, 50, 250, 50);

		contentPane.add(label);

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

	} // Constructor

	public void actionPerformed(ActionEvent e) {

		String menu;
		menu = e.getActionCommand();

		if(menu.equals("Quit")) {

			System.exit(0);

		} else {

			label.setText("ܤF" + "Menu " + menu );

		} //esle

	} // actionPerformed

	private void createFile() {

		JMenuItem item;

		file = new JMenu("File");

		item = new JMenuItem("New");
		item.addActionListener(this);
		file.add(item);

		item = new JMenuItem("Open...");
		item.addActionListener(this);
		file.add(item);

		item = new JMenuItem("Save");
		item.addActionListener(this);
		file.add(item);

		item = new JMenuItem("Save As...");
		item.addActionListener(this);
		file.add(item);

		file.addSeparator();// [W@ju

		ButtonGroup group = new ButtonGroup();
		rbmi = new JRadioButtonMenuItem("Radio Button Option 1");
		group.add(rbmi);
		rbmi.addActionListener(this);
		file.add(rbmi);

		rbmi = new JRadioButtonMenuItem("Radio Button Option 2");
		group.add(rbmi);
		rbmi.addActionListener(this);
		file.add(rbmi);

		rbmi = new JRadioButtonMenuItem("Radio Button Option 3");
		group.add(rbmi);
		rbmi.addActionListener(this);
		file.add(rbmi);

		file.addSeparator();// [W@ju

		cbmi = new JCheckBoxMenuItem("CheckBox Option 1");
		cbmi.addActionListener(this);
		file.add(cbmi);

		cbmi = new JCheckBoxMenuItem("CheckBox Option 2");
		cbmi.addActionListener(this);
		file.add(cbmi);

		file.addSeparator(); // [W@ju

		item = new JMenuItem("Quit");
		item.addActionListener(this);
		file.add(item);

	} // createFile()

	private void createEdit() {

		JMenuItem item;

		edit = new JMenu("Edit");

		item = new JMenuItem("Cut");
		item.addActionListener(this);
		edit.add(item);

		item = new JMenuItem("Copy");
		item.addActionListener(this);
		edit.add(item);

		item = new JMenuItem("Paste");
		item.addActionListener(this);
		edit.add(item);

	} // createEdit()

} // JCheckBoxMenuItemDemo1

