
/*
 * JList Demo 1
 *
 * إߤ@List
 */

import java.awt.*;

import java.awt.event.*;

import javax.swing.*;



class JListDemo1 extends JFrame implements ActionListener{

	private JList list;

	public static void main(String args[]) {

		JListDemo1 jl = new JListDemo1();

		jl.setVisible(true);

	} // main

	public JListDemo1() {

		Container contentPane = getContentPane();
		JPanel listPanel, okPanel;
		JButton ok;
		String [] sports = {"Swimming", "Tennis", "Golf", "Car Racing", "Basketball", "Baseball"};

		// Set up JFrame
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setTitle("JListDemo1.java");
		setSize(300, 250);
		setLocation(150, 250);

		contentPane.setLayout(new BorderLayout());

		list = new JList(sports);
		list.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

		listPanel = new JPanel(new FlowLayout());
		listPanel.add(list);
		listPanel.setBorder(BorderFactory.createTitledBorder("Favorite Sport"));

		ok = new JButton("Favorite");
		ok.addActionListener(this);

		okPanel = new JPanel(new FlowLayout());
		okPanel.add(ok);

		contentPane.add(listPanel, BorderLayout.CENTER);
		contentPane.add(okPanel, BorderLayout.SOUTH);

	} // Constructor

	public void actionPerformed(ActionEvent e) {

		String sports = "Your beloved sports are : \n";
		Object[] s = list.getSelectedValues();
		int loc[] = list.getSelectedIndices();
		String temp;

		for( int i = 0; i < s.length; i++) {
			temp = (String) s[i];
			sports =  sports +"# "+ temp + ", located at " + loc[i] + "\n";
		} // for

		JOptionPane.showMessageDialog(null, sports);

	} // actionPerformed

} // JListDemo1
