/*
 * JDBC Demo 12
 *
 * mߦbResult Set椤[J@
 */

import java.sql.*;

class JdbcDemo12{

    public static void main (String[] args) {
        try {

            // Ĥ@BGŪi JDBC Driver
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");

            // ĤGBGإ߻PƮws
            String url = "jdbc:odbc:Store";
            Connection conn = DriverManager.getConnection(url);

			// ĤTBGŧiStatement for sending SQL statements to the database
			// [JCONCUR_UPDATABLEѼiHQק
			Statement stmt = conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,
			ResultSet.CONCUR_UPDATABLE);

			ResultSet rs = stmt.executeQuery("SELECT * FROM Package where ID < 20");

			rs.moveToInsertRow();
			rs.updateString("senderName", "Olive");
			rs.updateString("receiverName", "Ruth");
			rs.updateInt("ID", 1);
			rs.updateFloat("Fee", 10.99f);
			rs.updateString("State", "On the way");
			rs.insertRow();

			rs = stmt.executeQuery("SELECT ID, senderName, State FROM Package where ID < 20");

			rs.moveToInsertRow();
			rs.updateString("senderName", "Olive");
			//rs.updateString("receiverName", "Ruth");
			rs.updateInt("ID", 1);
			//rs.updateFloat("Fee", 10.99f);
			rs.updateString("State", "On the way");
			rs.insertRow();

			rs.close();
			stmt.close();
			conn.close();

        } catch(SQLException e) {
			System.err.println(e.getMessage());
			}catch (Exception e) {
           		System.err.println(e.getMessage());
        }  // catch

    }  // main

} // JdbcDemo12
