/*
 * JDBC Demo 8
 *
 * ϥResult Seto
 */

import java.sql.*;

class JdbcDemo8{

    public static void main (String[] args) {
        try {

            // Ĥ@BGŪi JDBC Driver
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");

            // ĤGBGإ߻PƮws
            String url = "jdbc:odbc:Store";
            Connection conn = DriverManager.getConnection(url);

			// ĤTBGŧiStatement for sending SQL statements to the database
			Statement stmt = conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,
							     ResultSet.CONCUR_READ_ONLY);

			ResultSet rs = stmt.executeQuery("SELECT ID, senderName, State FROM Package where ID < 20");

			while(rs.next()) {
				int id = rs.getInt("ID");
				String sender = rs.getString("senderName");
				String state = rs.getString("State");
				System.out.println(id + "\t" + sender + "\t" + state);

			} // while

			rs.close();
			stmt.close();
			conn.close();

        } catch (Exception e) {
            System.err.println(e.getMessage());
        }  // catch

    }  // main

} // JdbcDemo8
