
/*
 * DoubleNode.java
 *
 * Doubly Linked ListNode
 */

class DoubleNode {

    Object data;

    DoubleNode prior;

    DoubleNode next;

    public DoubleNode() {

        this(null);

    } // Constructor

    public DoubleNode(Object data) {

        this(data, null, null);

    } // Constructor

    public DoubleNode(Object data, DoubleNode prior, DoubleNode next) {

        this.data = data;
        this.prior = prior;
        this.next = next;

    } // Constructor

    /**
     * @Ǧ^rӪܦ DoubleNode.
     **/

    public String toString() {

        return data.toString();

    } // toString()

} // DoubleNode

