/*******************************************************************************
Main Class File:  <Test.java>
File:             <HashTable.java>

Author:           <Shan-Huen Huang>

Completion Date:  <25/07/2004>

Compiler:         CodeWarrior IDE 3.3 (JDK 1.2)
Platform:         Unix (Solaris)
Description: 	<@ӼHash Table{>
*******************************************************************************/

import java.io.*;
import java.util.Vector;

/**
 * HashTable class
 * ]tkG insert,delete,lookup,dump,displayStats
 * Bugs: Not found.
 **/

class HashTable {

    int initSize;// Hash arrayjp
    double loadFactor;// Load Factor
    Vector[] table; // the hash array
    int sum; // array

    /**
     * The constructor
     * @param initSizeGhashtableljp
     * @param loadFactorGhashtablebrehashe̤jeq
     **/

    public HashTable(int initSize, double loadFactor)
    {
		this.initSize=initSize;
		this.loadFactor=loadFactor;
        table=new Vector[initSize];
        sum=0;

	} // Constructor

	/**
	 * The Load method
	 * Mwثe loadFactor
	 **/

	private float Load()
	{
		return ((float)sum/(float)initSize);

	} // Load()

	/**
	 * hash Function method
	 * ΨӨMwhash codeApiݩarrayӦmC
	 * @param itemGnQMw hash code.
	 **/

	private int hashFun(Object item)
	{
		int index=item.hashCode();

		if(index%initSize<0)
			return (index%initSize)+initSize;
		else
			return index%initSize;

	} // hashFun()

    /**
     * The lookup method
     * pGhǦ^Ӫ
     * @param itemGM䪺
     **/

    public Object lookup(Object item)
    {

       if(table[hashFun(item)]==null)
       {
		   return null;
		   }
       		else if(table[hashFun(item)].contains(item))
       		{
				return item;
				}
				else
					return null;

	} // lookup()

	/**
	 * The insert method
	 * pGJm(null)Ahإߤ@ӷs vector.
	 * pGload factorjL̤j load factor, hإߤ@ӸjarrayM rehash.
	 * @param itemGQJhashtable.
	 **/

	public void insert(Object item)
 	{

	     if(table[hashFun(item)]==null) {

			 Vector vec=new Vector();
			 table[hashFun(item)]=vec;
			 table[hashFun(item)].addElement(item);

		 } else {

				table[hashFun(item)].addElement(item);

		 } // else

        	sum++;

		 if(Load()>loadFactor) {

            reHash();

		 } // if

	 } // insert()

    /**
     * The method reHash
     * sy@Ө⭿jpshash table
     * o}CҦåBھhash codebs}C
     * s}C hashtable array
     **/

    private void reHash() {

		int tempSize=initSize;
		initSize=initSize*2+1;
		Vector[] newTable=new Vector[initSize];

		for(int i=0;i<tempSize;i++)
		{
			if(table[i]!=null)
			{
				for(int j=0;j<table[i].size();j++)
				{
					Object newItem=table[i].elementAt(j);

                    if(newTable[hashFun(newItem)]==null)
                    {
						Vector v=new Vector();
						newTable[hashFun(newItem)]=v;
						newTable[hashFun(newItem)].addElement(newItem);
					}
					else
					{
							newTable[hashFun(newItem)].addElement(newItem);

					} // else

				}// for

			}// if

		}// for

		table = new Vector[initSize];
		table = newTable;

	}// rehash()


	/**
	 * The delete method
	 * YñqhashtableNR
	 * pG쪺ܧRöǦ^ӪA_hǦ^null.
	 * @param itemGQR
	 **/

	public Object delete(Object item) {

		if(table[hashFun(item)]==null)
			return null;

		if(table[hashFun(item)].contains(item))
		{
			table[hashFun(item)].removeElement(item);
			sum--;
			return item;

		} // if
		else

			return null;

	} // delete()

    /**
     * The dump method
     * NhashtableqY}lCLX from the begining
     * @param outGtοXk
     **/

    public String dump()
    {
		String str = "";
		for(int i=0;i<initSize;i++)
		{
            if(table[i] != null)
				str = str + table[i].toString() + "\n";
		} // for

		return str;

	} // dump()

    /**
     * The displayStats method
     * CLXhashtableثeAApjpAƥإH load factor,
     * @param outGtοXk
     **/

    public String displayStats() {

		float avg=0;
		int nonchain=0;
		int longchain=0;
		String str;

		for(int i=0;i<initSize;i++)
		{
			if(table[i]==null)
			nonchain++;
			else
			{
				if(!(table[i].size()<longchain))
				longchain=table[i].size();
			} // else

		}// for

		avg=(float)sum/(float)(initSize-nonchain);

		return str = "Hashtable Statistics:\n" +
		"Current table size:\t" + initSize +
		"\n# of items in table:\t" + sum +
		"\nCurrent load factor:\t" + Load() +
		"\nLongest chain length:\t" + longchain +
		"\n# of 0-length chains:\t" + nonchain +
		"\nAvg (non-0) chain length:\t" + avg + "\n";

	} // displayStats()

}//end of HashTable