/*
 * TowersOfHanoi.java
 *
 * Towers Of Hanoi{
 */

import java.awt.*;

import java.awt.event.*;

import javax.swing.*;

public class TowersOfHanoi extends JFrame implements ActionListener{

	JLabel prompt1, prompt2, prompt3;
	JTextField input1;
	JTextArea output1;
	JButton start;
	JPanel north, south;
	JScrollPane jsp;
	int n;

	public static void main(String args[]) {

		TowersOfHanoi toh = new TowersOfHanoi();
		toh.setVisible(true);

	} // main

	public TowersOfHanoi(){

		Container contentPane = getContentPane();
		setTitle("Towers of Hanoi");
		setSize(450, 600);
		setLocation(250, 300);
		contentPane.setLayout(new BorderLayout());

		prompt1 = new JLabel("JӼ");
		input1 = new JTextField(5);
		prompt2 = new JLabel("B⵲GG");

		north = new JPanel(new FlowLayout());
		north.add(prompt1);
		north.add(input1);
		north.add(prompt2);

		output1 = new JTextArea();
		output1.setEditable(false);
		jsp = new JScrollPane(output1);
		jsp.setBorder(BorderFactory.createLineBorder(Color.red));

		prompt3 = new JLabel("Status");
		start = new JButton("Start");
		start.addActionListener(this);

		south = new JPanel(new FlowLayout());
		south.add(prompt3);
		south.add(start);

		contentPane.add(north, BorderLayout.NORTH);
		contentPane.add(jsp, BorderLayout.CENTER);
		contentPane.add(south, BorderLayout.SOUTH);

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		}//TowersOfHanoi()

	public void actionPerformed(ActionEvent e) {
		n = Integer.parseInt(input1.getText());
		prompt3.setText("Calculating...");

		towers(n, 'A', 'C', 'B');

		output1.append("\n\n");
		prompt3.setText("Done.");

		}//action()

	void towers(int n, char fromPeg, char toPeg, char auxPeg) {
		if(n==1){
			output1.append("\nN 1 q " + fromPeg + " W " + toPeg + "W");
			return;
			}//if
		towers(n-1, fromPeg, auxPeg, toPeg);
		output1.append("\nN " + n + " qW " + fromPeg + " W "+ toPeg);
		towers(n-1, auxPeg, toPeg, fromPeg);
		}//towers()

	}//TowersOfHanoi