
/*
 * QuickSort.java
 *
 * ϥQuick SorttkӱƧǰ}C
 */

 class QuickSort
  {
	int record[] = {5, 7, 12, 3, 9, 33, 23, 11, 1, 34, 55, 2, 66
	   , 8, 10, 39, 77, 99, 13, 96, 17, 21, 56, 43, 92, 25, 35};

	private final static int CUTOFF = 3;

	public QuickSort(){

		quicksort(record);
		printArray(record);

	} // Constructor

    public static void main(String args[]){

	 	new QuickSort();

	}//main

	public void quicksort(int r[]){

		quicksort(r, 0, r.length -1);

	}// quicksort()

	private static void quicksort(int a[], int low, int high){

		if( low + CUTOFF > high)
			insertionSort(a, low, high);

		else{

			int middle = ( low + high ) / 2;

			if( a[middle] < a[low])
				swapReferences( a, low, middle );

			if( a[high] < a[low])
				swapReferences( a, low, high );

			if( a[high] < a[middle])
				swapReferences( a, middle, high );

			swapReferences( a, middle, high - 1);
			int pivot = a[high -1];

			int i, j;
			for( i = low, j = high - 1; ;)
			{
				while( a[++i] < pivot )
					;
				while( pivot < a[--j] )
					;
				if( i < j )
					swapReferences( a, i, j);
				else
					break;

			}//for

			swapReferences( a, i, high - 1);

			quicksort( a, low, i - 1);
			quicksort( a, i + 1, high);

			}//else

		}// quicksort()

	private static int[] swapReferences(int a[], int j, int k){

		int temp = a[j];
		a[j] = a[k];
		a[k] = temp;
		return a;

	}// swapReferences()

	private static void insertionSort(int r[], int l, int h){

		for(int p = l; p <= h ; p++) {

			int temp = r[p];
			int j = p;

			for ( ; j > 0 && temp < r[j-1] ; j--) {

				r[ j ] = r[ j - 1];

			}//for

			r[j] = temp;

	   }//for

	}//insertionSort()

	private static void printArray(int p[]){

		for(int i = 0; i < p.length; i++){

			System.out.print(p[i]+"  ");

			}//for

		}//printArray

}//QuickSort



