/*
 * ShellSort.java
 */

 class ShellSort {

	int record[] = {5, 7, 12, 3, 9, 33, 23, 11,35,33,22,15};

	public ShellSort() {

		int increments[]= {5, 3, 1};

		Process(increments);
		printArray();

	} // Constructor

    public static void main(String args[]) {

	 	new ShellSort();

	}//main

	public void Process(int increments[]) {

	  int incr, j, k, span, y;

	  for(incr = 0; incr < increments.length; incr++) {

		  span = increments[incr]; // span is the size of increment

		  for(j = span; j < record.length; j++) {

			  y = record[j];

			  for ( k = j - span; k >= 0 && y < record[k]; k -= span)
			  	record[k + span] = record[k];

			  record[k + span] = y;

		 }//for

	  }//for

	}//Process()

	private void printArray() {

		for(int i = 0; i < record.length; i++) {

			System.out.print(record[i]+"  ");

		}//for

	}//printArray

}//ShellSort



