public class ShortestPath{

	public static int shortPath(Arc weight[ ][ ], int numNodes, int s, int t, int precede[ ]) {

		final int INFINITY = Integer.MAX_VALUE;
		final int MAXNODES = numNodes;
		final boolean MEMBER = true;
		final boolean NONMEMBER = false;

		int distance[ ] = new int [MAXNODES];
		boolean perm[ ] = new boolean[MAXNODES];
		int current = 0, k = 0, dc = 0;
		int smallDist = 0, newDist = 0;

		// l
		for (int i = 0; i < MAXNODES; i++) {
			perm[i] = NONMEMBER;
			distance[i] = INFINITY;
			}//for

		perm[s] = MEMBER;
		distance[s] = 0;
		current =s;

		while (current != t) {
			smallDist = INFINITY;
			dc = distance[current];

			for (int i = 0; i < MAXNODES; i++)

				if (perm[i] == NONMEMBER) {

					if ( dc == Integer.MAX_VALUE || weight[current][i].getWeight() == Integer.MAX_VALUE)
						newDist = Integer.MAX_VALUE;
					else
						newDist = dc + weight[current][i].getWeight();

					if (newDist < 0)
						newDist = INFINITY;

					if(newDist < distance[i]) {
						distance[i] = newDist;
						precede[i] = current;
					} // if

					if (distance[i] < smallDist) {
						smallDist = distance[i];
						i = i;
					} // if

				}//if

				current = k;
				perm[current] = MEMBER;

		}//while

			return distance[t];

	}//shortPath

}//ShortedstPath
