/*
 * main method : PokerGame.java
 *
 * class needed : canvas.java, cards.java, getCards.java, judgeCards.java
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class PokerGame extends JFrame {

	private static final int CardWidth = 80;
	private static final int CardHeight = 120;
	private static final int ButtonWidth = 70;
	private static final int ButtonHeight = 30;

	canvas can1;
	canvas can2;
	canvas can3;
	canvas can4;
	canvas can5;

	JButton c1, c2, c3, c4, c5;
	JButton bet;
	JButton deal;
	JButton quit;

	int credit = 1000;

	JLabel creditInfo;
	JLabel cardInfo;
	JLabel betInfo;

	int betCount = 0;

	boolean newSet = false;

	boolean change = false;
	boolean change1 = false;
	boolean change2 = false;
	boolean change3 = false;
	boolean change4 = false;
	boolean change5 = false;

	int dealPressed = 0;
	int clickCount1 = 0;
	int clickCount2 = 0;
	int clickCount3 = 0;
	int clickCount4 = 0;
	int clickCount5 = 0;

	int gameCount = 0;

	getCards gc=new getCards(); ;
	judgeCards jc;

	String result;
	String img1, img2, img3, img4, img5;
	String changeCards = "";

	public static void main(String args[]) {

		PokerGame pg = new PokerGame();
		pg.setVisible(true);

	}//main

	public PokerGame () {

		Container contentPane = getContentPane();

		// set the frame properties
		JFrame.setDefaultLookAndFeelDecorated(true);

		setTitle("Poker Game");
		setSize(470, 300);
		setResizable(false);
		setLocation(350, 350);

		// set the content Pane properties
		contentPane.setLayout(null);
		contentPane.setBackground(Color.green);

		// create 5 canvas and place in to the frame's content pane
		can1 = new canvas("bg.jpg");
		can1.setBounds(20, 50, CardWidth, CardHeight);

		can2 = new canvas("bg.jpg");
		can2.setBounds(110, 50, CardWidth, CardHeight);

		can3 = new canvas("bg.jpg");
		can3.setBounds(200, 50, CardWidth, CardHeight);

		can4 = new canvas("bg.jpg");
		can4.setBounds(290, 50, CardWidth, CardHeight);

		can5 = new canvas("bg.jpg");
		can5.setBounds(380, 50, CardWidth, CardHeight);

		c1 = new JButton("\P");
		c1.setBounds(20, 180, ButtonWidth, ButtonHeight);
		c1.setForeground(Color.blue);

		c2 = new JButton("\P");
		c2.setBounds(110, 180, ButtonWidth, ButtonHeight);
		c2.setForeground(Color.blue);

		c3 = new JButton("\P");
		c3.setBounds(200, 180, ButtonWidth, ButtonHeight);
		c3.setForeground(Color.blue);

		c4 = new JButton("\P");
		c4.setBounds(290, 180, ButtonWidth, ButtonHeight);
		c4.setForeground(Color.blue);

		c5 = new JButton("\P");
		c5.setBounds(380, 180, ButtonWidth, ButtonHeight);
		c5.setForeground(Color.blue);

		c1.addActionListener(new hold_1_ActionListener());
		c2.addActionListener(new hold_2_ActionListener());
		c3.addActionListener(new hold_3_ActionListener());
		c4.addActionListener(new hold_4_ActionListener());
		c5.addActionListener(new hold_5_ActionListener());

		deal = new JButton("oP");
		deal.setBounds(290, 220, ButtonWidth, ButtonHeight);
		deal.setForeground(Color.magenta);

		quit = new JButton("");
		quit.setBounds(380, 220, ButtonWidth, ButtonHeight);
		quit.setForeground(Color.magenta);

		deal.addActionListener(new MyActionListener());
		quit.addActionListener(new quitActionListener());

		creditInfo = new JLabel("<html><font size=6 color=pink>1000</font></html>");
		creditInfo.setBounds(20, 10, 200, 30);

		cardInfo = new JLabel("<html><font size=6 color=red>P</font></html>");
		cardInfo.setBounds(300, 10, 100, 30);

		bet = new JButton("X10");
		bet.setBounds(20, 220, 70, 30);
		bet.addActionListener(new BetActionListener());

		betInfo = new JLabel("<html><font size=5 color=red>`</font></html>");
		betInfo.setBounds(150, 220, 70, 30);

		contentPane.add(creditInfo);
		contentPane.add(cardInfo);

		contentPane.add(can1);
		contentPane.add(can2);
		contentPane.add(can3);
		contentPane.add(can4);
		contentPane.add(can5);

		contentPane.add(c1);
		contentPane.add(c2);
		contentPane.add(c3);
		contentPane.add(c4);
		contentPane.add(c5);

		contentPane.add(bet);
		contentPane.add(betInfo);

		contentPane.add(deal);
		contentPane.add(quit);

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

	}//Constructor

	class MyWindowListener extends WindowAdapter {

		public void windowClosing(WindowEvent e) {

			System.exit(1);

		} // windowClosing()

	}//MyWindwoListener

	class MyActionListener implements ActionListener {

		public void actionPerformed(ActionEvent e) {

			if (change1 || change2 || change3 || change4 || change5) {

				change=true;

			} // if

			if(e.getActionCommand().equals("oP") && dealPressed%2==0) {

				System.out.println("Deal & change false");

				newSet = true;

				clickCount1 = 0;
				clickCount2 = 0;
				clickCount3 = 0;
				clickCount4 = 0;
				clickCount5 = 0;

				change1 = false;
				change2 = false;
				change3 = false;
				change4 = false;
				change5 = false;

				c1.setEnabled(true);
				c2.setEnabled(true);
				c3.setEnabled(true);
				c4.setEnabled(true);
				c5.setEnabled(true);

				gc.resetCards();
				gc.get5Cards();
				gc.cards_5=gc.SortCards();

				img1 = gc.cards_5[0].cardString()+".jpg";
				img2 = gc.cards_5[1].cardString()+".jpg";
				img3 = gc.cards_5[2].cardString()+".jpg";
				img4 = gc.cards_5[3].cardString()+".jpg";
				img5 = gc.cards_5[4].cardString()+".jpg";

				System.out.println(img1 + "\t" + img2 + "\t" + img3 + "\t" + img4 + "\t" + img5);

				can1.image = can1.getImage(img1);
				can2.image = can2.getImage(img2);
				can3.image = can3.getImage(img3);
				can4.image = can4.getImage(img4);
				can5.image = can5.getImage(img5);

				can1.repaint();
				can2.repaint();
				can3.repaint();
				can4.repaint();
				can5.repaint();

				jc=new judgeCards(gc.cards_5);
				result = jc.judge();

				credit = credit - Integer.parseInt(betInfo.getText().trim());
				creditInfo.setText("<html><font size=6 color=pink>"
				+ Integer.toString(credit) + "</font></html>");
				gameCount++;

				System.out.println("# of games = " + gameCount);
				bet.setEnabled(false);
				dealPressed++;

				return;

			}//if

			if(e.getActionCommand().equals("oP") && dealPressed%2==1){

				System.out.println("Deal & chnage true");
				System.out.println("change =" + change);
				changeCards = "";

					if(change1 == true) {
						changeCards = changeCards + "1 ";
					}// if(change1 == true)

					if(change2 == true)	{
						changeCards = changeCards + "2 ";
					}// if(change1 == true)

					if(change3 == true)	{
						changeCards = changeCards + "3 ";
					}// if(change1 == true)

					if(change4 == true)	{
						changeCards = changeCards + "4 ";
					}// if(change1 == true)

					if(change5 == true)	{
						changeCards = changeCards + "5 ";
					}// if(change1 == true)

				changeCards = changeCards.trim();

				gc.cards_5 = gc.getMoreCards(changeCards);
				getCards gc2 = new getCards();

				for (int i = 0; i < 5; i++ ) {
					gc2.cards_5[i] = gc.cards_5[i];
				} // for

				gc2.cards_5 = gc2.SortCards();

				img1 = gc.cards_5[0].cardString()+".jpg";
				img2 = gc.cards_5[1].cardString()+".jpg";
				img3 = gc.cards_5[2].cardString()+".jpg";
				img4 = gc.cards_5[3].cardString()+".jpg";
				img5 = gc.cards_5[4].cardString()+".jpg";

				can1.image = can1.getImage(img1);
				can2.image = can2.getImage(img2);
				can3.image = can3.getImage(img3);
				can4.image = can4.getImage(img4);
				can5.image = can5.getImage(img5);

				can1.repaint();
				can2.repaint();
				can3.repaint();
				can4.repaint();
				can5.repaint();

				jc=new judgeCards(gc2.cards_5);
				result = jc.judge();
				cardInfo.setText("<html><font size=6 color=red>" + result + "</font></html>");
				credit = credit + Integer.parseInt(betInfo.getText().trim()) * jc.ratio;

				creditInfo.setText("<html><font size=6 color=pink>"
				+ Integer.toString(credit) + "</font></html>");

				newSet = true;

				clickCount1 = 0;
				clickCount2 = 0;
				clickCount3 = 0;
				clickCount4 = 0;
				clickCount5 = 0;

				change = false;
				change1 = false;
				change2 = false;
				change3 = false;
				change4 = false;
				change5 = false;
				gc.resetCards();

				c1.setEnabled(false); //add
				c2.setEnabled(false); //add
				c3.setEnabled(false); //add
				c4.setEnabled(false); //add
				c5.setEnabled(false); //add
				betCount=0;
				bet.setEnabled(true);

				System.gc();
				dealPressed++;
				return;

			}// if

		}// actionPerformed

	}// MyActionListener

	class hold_1_ActionListener implements ActionListener {

		public void actionPerformed(ActionEvent e) {

			clickCount1++;
			System.out.println("# of click1 = " + clickCount1);

			if(newSet){

				if(clickCount1%2 == 1)	{

					change1 = true;
					can1.image = can1.getImage("bg.jpg");
					can1.repaint();

				} // if

				if(clickCount1%2 == 0)	{

					change1 = false;
					can1.image = can1.getImage(img1);
					can1.repaint();

				}// if

			} // if

		}// actionPerformed

	}// hold_1_ActionListener

	class hold_2_ActionListener implements ActionListener {

		public void actionPerformed(ActionEvent e) {

			clickCount2++;
			System.out.println("# of click2 = " + clickCount2);

			if(newSet){

				if(clickCount2%2 == 1)	{

					change2 = true;
					can2.image = can2.getImage("bg.jpg");
					can2.repaint();

				} // if

				if(clickCount2%2 == 0) {

					change2 = false;
					can2.image = can2.getImage(img2);
					can2.repaint();

				} // if

			}// if

		}// actionPerformed

	}// hold_2_ActionListener

	class hold_3_ActionListener implements ActionListener {

		public void actionPerformed(ActionEvent e) {

			clickCount3++;
			System.out.println("# of click3 = " + clickCount3);

			if(newSet) {

				if(clickCount3%2 == 1) {

					change3 = true;
					can3.image = can3.getImage("bg.jpg");
					can3.repaint();

				} // if

				if(clickCount3%2 == 0) {

					change3 = false;
					can3.image = can3.getImage(img3);
					can3.repaint();

				}// if

			}// if

		}// actionPerformed

	}// hold_3_ActionListener

	class hold_4_ActionListener implements ActionListener {

		public void actionPerformed(ActionEvent e) {

			clickCount4++;
			System.out.println("# of click4 = " + clickCount4);

			if(newSet){

				if(clickCount4%2 == 1)	{

					change4 = true;
					can4.image = can4.getImage("bg.jpg");
					can4.repaint();

				}// if

				if(clickCount4%2 == 0)	{

					change4 = false;
					can4.image = can4.getImage(img4);
					can4.repaint();

				}// if

			} // if

		}// actionPerformed

	}// hold_4_ActionListener

	class hold_5_ActionListener implements ActionListener {

		public void actionPerformed(ActionEvent e) {

			clickCount5++;
			System.out.println("# of click5 = " + clickCount5);

			if(newSet) {

				if(clickCount5%2 == 1) {

					change5 = true;
					can5.image = can5.getImage("bg.jpg");
					can5.repaint();

				} // if

				if(clickCount5%2 == 0) {

					change5 = false;
					can5.image = can5.getImage(img5);
					can5.repaint();

				} // if

			}// if

		}// actionPerformed

	}// hold_5_ActionListener

	class BetActionListener implements ActionListener {

		public void actionPerformed(ActionEvent e)	{

			if(dealPressed%2 == 0) {

				betCount++;
				betInfo.setText(Integer.toString(betCount*10));

			} // if

		}// actionPerformed

	}// BetActionListener

	class quitActionListener implements ActionListener {

		public void actionPerformed(ActionEvent e) {

			System.exit(1);

		}// actionPerformed

	}// quitActionListener

}//PokerGame

