
/*
 * LayoutManager Demo 4
 *
 * mߨϥGrid Layout Manger
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


class LayoutManagerDemo4 extends JFrame{

	private JButton b1, b2, b3, b4, b5, b6, b7, b8, b9;

	private JLabel label1, label2;

	private JPanel left, right, option, control, leftup, leftdown;

	public static void main(String args[]) {

		LayoutManagerDemo4 LM = new LayoutManagerDemo4();

		LM.setVisible(true);

	} // main

	public LayoutManagerDemo4() {

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		setTitle("LayoutMangerDemo4.java");
		setSize(600, 400);
		setLocation(150, 250);
		//setBorder(BorderFactory.createTitledBorder("contentPane"));

		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout(20, 0));

		b1 = new JButton("button 1");
		b2 = new JButton("button 2");
		b3 = new JButton("button 3");
		b4 = new JButton("button 4");
		b5 = new JButton("button 5");
		b6 = new JButton("button 6");
		b7 = new JButton("button 7");
		b8 = new JButton("button 8");
		b9 = new JButton("button 9");

		label1 = new JLabel("label1");
		label2 = new JLabel("label2");
		label1.setBorder(BorderFactory.createTitledBorder("label1"));
		label2.setBorder(BorderFactory.createTitledBorder("label2"));
		label1.setSize(150, 100);
		label2.setSize(150, 100);

		option = new JPanel(new FlowLayout());
		option.setBorder(BorderFactory.createTitledBorder("option"));
		control = new JPanel(new GridLayout(3, 1, 10, 10));
		control.setBorder(BorderFactory.createTitledBorder("control"));

		option.add(b1);
		option.add(b2);
		option.add(b3);

		control.add(b4);
		control.add(b5);
		control.add(b6);

		leftup = new JPanel(new FlowLayout(FlowLayout.CENTER, 50, 0));
		leftup.setBorder(BorderFactory.createTitledBorder("leftup"));
		leftup.add(label1);
		leftup.add(label2);

		leftdown = new JPanel(new FlowLayout());
		leftdown.setBorder(BorderFactory.createTitledBorder("leftdown"));
		leftdown.add(b7);
		leftdown.add(b8);
		leftdown.add(b9);

		left = new JPanel(new GridLayout(2, 1, 0, 200));
		left.setBorder(BorderFactory.createTitledBorder("left"));
		left.add(leftup);
		left.add(leftdown);

		right = new JPanel(new BorderLayout());
		right.setBorder(BorderFactory.createTitledBorder("right"));
		right.add(option, BorderLayout.NORTH);
		right.add(control, BorderLayout.SOUTH);

		contentPane.add(left, BorderLayout.CENTER);
		contentPane.add(right, BorderLayout.EAST);

	} // Constructor

} // LayoutManagerDemo4

