
/*
 * MouseEvent Demo 1
 *
 * ƹI諸m
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class MouseEventDemo1 extends JFrame implements MouseListener{

	public static void main(String args[]) {

		MouseEventDemo1 ME = new MouseEventDemo1();

		ME.setVisible(true);

	} // main

	public MouseEventDemo1() {

		Container contentPane = getContentPane();

		contentPane.setBackground(Color.green);

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		setTitle("MouseEventDemo1.java");

		setSize(300, 200);

		setLocation(150, 250);

		addMouseListener(this);

	} // Constructor

	public void mouseClicked(MouseEvent e) {

		if (e.getClickCount() == 2) {

			System.exit(0);

		} else {

			int x, y;

			x = e.getX();
			y = e.getY();

			JOptionPane.showMessageDialog(null, "You clicked on " + x + ", " + y);

		} // else

	} // mouseClicked

	public void mouseEntered(MouseEvent e) {

		System.out.println("Mouse Enter.");

	} //mouseEntered

	public void mouseExited(MouseEvent e) {

		System.out.println("Mouse Exit.");

	} //mouseExited

	public void mousePressed(MouseEvent e) {

		System.out.println("Mouse Down");

	} //mousePressed

	public void mouseReleased(MouseEvent e) {

		System.out.println("Mouse Up.");

	} //mouseReleased

} // MouseEventDemo1
